/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef INCL_TAG_NAMES
#define INCL_TAG_NAMES

// The class includes the name of the tag that are used into the parser

#include "base/fscapi.h"
#include "syncml/core/core.h"

#define SYNC_ML             TEXT("SyncML"           )
#define SYNC_BODY           TEXT("SyncBody"         )
#define SYNC_HDR            TEXT("SyncHdr"          )
#define SESSION_ID          TEXT("SessionID"        )
#define VER_PROTO           TEXT("VerProto"         )
#define VER_DTD             TEXT("VerDTD"           )
#define MSG_ID              TEXT("MsgID"            )
#define RESP_URI            TEXT("RespURI"          )
#define NO_RESP             TEXT("NoResp"           )
#define NO_RESULTS          TEXT("NoResults"        )
#define ARCHIVE             TEXT("Archive"          )
#define SFT_DEL             TEXT("SftDel"           )
#define SOURCE              TEXT("Source"           )
#define TARGET              TEXT("Target"           )
#define LOC_URI             TEXT("LocURI"           )
#define LOC_NAME            TEXT("LocName"          )
#define ANCHOR              TEXT("Anchor"           )
#define CRED                TEXT("Cred"             )
#define LAST                TEXT("Last"             )
#define NEXT                TEXT("Next"             )
#define NEXT_NONCE          TEXT("NextNonce"        )
#define FREE_MEM            TEXT("FreeMem"          )
#define SHARED_MEM          TEXT("SharedMem"        )
#define FREE_ID             TEXT("FreeID"           )
#define MAX_MEM             TEXT("MaxMem"           )
#define MAX_ID              TEXT("MaxID"            )
#define FORMAT              TEXT("Format"           )
#define TYPE                TEXT("Type"             )
#define MARK                TEXT("Mark"             )
#define VERSIONSTR          TEXT("Version"          )
#define MAX_MESSAGE_SIZE    TEXT("MaxMsgSize"       )
#define MAX_OBJ_SIZE        TEXT("MaxObjSize"       )
#define SIZE                TEXT("Size"             )
#define VERSIONSTR          TEXT("Version"          )
#define DATA                TEXT("Data"             )
#define FINAL_MSG           TEXT("Final"            )
#define NO_RESP             TEXT("NoResp"           )
#define CMD_ID              TEXT("CmdID"            )
#define COMPLEX_DATA        TEXT("Data"             ) 
#define MORE_DATA           TEXT("MoreData"         )
#define META                TEXT("Meta"             )
#define STATUS              TEXT("Status"           )
#define MSG_REF             TEXT("MsgRef"           )
#define CMD_REF             TEXT("CmdRef"           )
#define TARGET_REF          TEXT("TargetRef"        )
#define SOURCE_REF          TEXT("SourceRef"        )
#define CHAL                TEXT("Chal"             )
#define CMD                 TEXT("Cmd"              )
#define ADD                 TEXT("Add"              )
#define SYNC                TEXT("Sync"             )
#define REPLACE             TEXT("Replace"          )
#define DEL                 TEXT("Delete"           )
#define MAP                 TEXT("Map"              )
#define MAP_ITEM            TEXT("MapItem"          )
#define COPY                TEXT("Copy"             )
#define ATOMIC              TEXT("Atomic"           )
#define SEQUENCE            TEXT("Sequence"         )
#define LANG                TEXT("Lang"             )
#define GET                 TEXT("Get"              )
#define PUT                 TEXT("Put"              )
#define SUPPORT_NUMBER_OF_CHANGES TEXT("SupportNumberOfChanges")
#define NUMBER_OF_CHANGES   TEXT("NumberOfChanges")
#define SUPPORT_LARGE_OBJECT TEXT("LargeObject"              )
#define UTC                 TEXT("Utc"              )
#define DATA_STORE          TEXT("DataStore"        )
#define MAN                 TEXT("Man"              )
#define MOD                 TEXT("Mod"              )
#define OEM                 TEXT("OEM"              )
#define FWV                 TEXT("FwV"              )
#define SWV                 TEXT("SwV"              )
#define HWV                 TEXT("HwV"              )
#define DEV_ID              TEXT("DevId"            )
#define DEV_TYP             TEXT("DevTyp"           )
#define DEV_INF             TEXT("DevInf"           )
#define DISPLAY_NAME        TEXT("DisplayName"      )
#define MAX_GUID_SIZE       TEXT("MaxGUIDSize"      )
#define RX_PREF             TEXT("Rx-Pref"          )
#define TX_PREF             TEXT("Tx-Pref"          )
#define CT_TYPE             TEXT("CTType"           )
#define VER_CT              TEXT("VerCT"            )
#define DS_MEM              TEXT("DSMem"            )
#define SYNC_CAP            TEXT("SyncCap"          )
#define SYNC_TYPE           TEXT("SyncType"         )
#define RX                  TEXT("Rx"               )
#define TX                  TEXT("Tx"               )
#define CT_CAP              TEXT("CTCap"            )
#define EXT                 TEXT("Ext"              )
#define XNAM                TEXT("XNam"             )
#define XVAL                TEXT("XVal"             )
#define RESULTS             TEXT("Results"          )
#define EXEC                TEXT("Exec"             )
#define SEARCH              TEXT("Search"           )
#define TARGET_PARENT       TEXT("TargetParent"     )
#define SOURCE_PARENT       TEXT("SourceParent"     )



// Commands
#define ALERT               TEXT("Alert"            )
#define ITEM                TEXT("Item"             )
#define FILTER              TEXT("Filter"           )
#define RECORD              TEXT("Record"           )
#define FIELD               TEXT("Field"            )
#define PROPERTY            TEXT("Property"         )
#define DISPLAY_NAME        TEXT("DisplayName"      )
#define PROP_NAME           TEXT("PropName"         )
#define DATA_TYPE           TEXT("DataType"         )
#define MAX_OCCUR           TEXT("MaxOccur"         )
#define MAX_SIZE            TEXT("MaxSize"          )
#define NO_TRUNCATE         TEXT("NoTruncate"       )
#define PROP_PARAM          TEXT("PropParam"        )
#define PARAM_NAME          TEXT("ParamName"        )
#define VAL_ENUM            TEXT("ValEnum"          )
#define VAL_ENUM            TEXT("ValEnum"          )
#define FILTER_TYPE         TEXT("FilterType"       )

#endif






