Attribute VB_Name = "Module3"
'
'Copyright (C) 2003-2004 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Const FUNAMBOL = "SOFTWARE\Funambol"
Const SYNCCLIENT = "SyncclientPIM"
Const SPDS = "spds"
Const SYNCML = "syncml"
Const SOURCES = "sources"
Const APPOINTMENTS = "appointments"
Const CONTACTS = "contacts"
Const TASKS = "tasks"
Const FAVORITES = "favorites"
Const FILEBACKUP = "files"
Const NOTES = "notes"





Public Const NO_ERROR = 0                           ' Function returned successfully.
Public Const ERROR_NONE = 0

Public Const HKEY_CURRENT_USER = &H80000001         ' Reference a section of the registry.
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_CLASSES_ROOT = &H80000000

Public Const KEY_ALL_ACCESS = &H3F                  ' This is a simplified version of the declaration in WINCEAPI.TXT
Public Const REG_DWORD = 4                          ' 32-bit number.
Public Const REG_OPTION_NON_VOLATILE = 0            ' Key is preserved when system is rebooted.
Public Const REG_SZ = 1                             ' Unicode nul terminated string.

Declare Function RegCloseKey Lib "Coredll" ( _
  ByVal hkey As Long) _
  As Long

Declare Function RegCreateKeyEx Lib "Coredll" Alias "RegCreateKeyExW" ( _
  ByVal hkey As Long, _
  ByVal lpSubKey As String, _
  ByVal Reserved As Long, _
  ByVal lpClass As String, _
  ByVal dwOptions As Long, _
  ByVal samDesired As Long, _
  ByVal lpSecurityAttributes As Long, _
  phkResult As Long, _
  lpdwDisposition As Long) _
  As Long
  
  Declare Function RegOpenKeyEx Lib "Coredll" Alias "RegOpenKeyExW" ( _
  ByVal hkey As Long, _
  ByVal lpSubKey As String, _
  ByVal ulOptions As Long, _
  ByVal samDesired As Long, _
  phkResult As Long) _
  As Long
  
  
  Declare Function RegSetValueExString Lib "Coredll" Alias "RegSetValueExW" ( _
  ByVal hkey As Long, _
  ByVal lpValueName As String, _
  ByVal Reserved As Long, _
  ByVal dwType As Long, _
  ByVal lpValue As String, _
  ByVal cbData As Long) _
  As Long
  
  Declare Function RegQueryValueEx Lib "Coredll" Alias "RegQueryValueExW" ( _
  ByVal hkey As Long, _
  ByVal lpValueName As String, _
  ByVal lpReserved As Long, _
  lpType As Long, _
  ByVal lpData As Long, _
  lpcbData As Long) _
  As Long
  
  Declare Function RegQueryValueExString Lib "Coredll" Alias "RegQueryValueExW" ( _
  ByVal hkey As Long, _
  ByVal lpValueName As String, _
  ByVal lpReserved As Long, _
  lpType As Long, _
  ByVal lpData As String, _
  lpcbData As Long) _
  As Long
  
Public Function populateRegistry()
    Dim ret As Long
    Dim ris As String
    Dim query As String
    'MsgBox "-" & ret & "-", vbOKOnly, "Saved"
    ret = CreateNewKey(FUNAMBOL)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SYNCML)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & APPOINTMENTS)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & CONTACTS)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & TASKS)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & FAVORITES)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & FILEBACKUP)
    ret = CreateNewKey(FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & NOTES)
    
    
    'MsgBox "-" & ret & "-", vbOKOnly, "Saved"
    
    query = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SYNCML
    ris = QueryValue(query, "deviceId")
    
    If Trim(ris) = "" Then
        'create empty pair key - value
        Dim SYNCML_PATH As String
        SYNCML_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SYNCML
        SetKeyValue SYNCML_PATH, "deviceId", "", REG_SZ
        SetKeyValue SYNCML_PATH, "username", "", REG_SZ
        SetKeyValue SYNCML_PATH, "password", "", REG_SZ
        SetKeyValue SYNCML_PATH, "syncUrl", "http://localhost:8080/sync4j/sync", REG_SZ
        SetKeyValue SYNCML_PATH, "serverName", "http://localhost:8080", REG_SZ
        SetKeyValue SYNCML_PATH, "beginTimestamp", "0", REG_SZ
        SetKeyValue SYNCML_PATH, "endTimestamp", "0", REG_SZ
        SetKeyValue SYNCML_PATH, "sourceCount", "0", REG_SZ
        
        'reserved
        SetKeyValue SYNCML_PATH, "firstTimeSyncMode", "0", REG_SZ
        SetKeyValue SYNCML_PATH, "proxyHost", "", REG_SZ
        SetKeyValue SYNCML_PATH, "proxyPort", "", REG_SZ
        SetKeyValue SYNCML_PATH, "useProxy", "", REG_SZ
        
        
        
        
        'For Appointments
        Dim SOURCE_PATH As String
        SOURCE_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & APPOINTMENTS
        SetKeyValue SOURCE_PATH, "sync", "none", REG_SZ
        SetKeyValue SOURCE_PATH, "last", "0", REG_SZ
        'SetKeyValue SOURCE_PATH, "name", "appointments", REG_SZ
        SetKeyValue SOURCE_PATH, "name", "./calendar", REG_SZ
        SetKeyValue SOURCE_PATH, "type", "text/plain", REG_SZ
        SetKeyValue SOURCE_PATH, "syncModes", "slow,two-way,refresh", REG_SZ
        SetKeyValue SOURCE_PATH, "uri", "./calendar", REG_SZ
        
        
        'For Contacts
        
        SOURCE_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & CONTACTS
        SetKeyValue SOURCE_PATH, "sync", "two-way", REG_SZ
        SetKeyValue SOURCE_PATH, "last", "0", REG_SZ
        'SetKeyValue SOURCE_PATH, "name", "contacts", REG_SZ
        SetKeyValue SOURCE_PATH, "name", "./contact", REG_SZ
        SetKeyValue SOURCE_PATH, "type", "text/plain", REG_SZ
        SetKeyValue SOURCE_PATH, "syncModes", "slow,two-way,refresh", REG_SZ
        SetKeyValue SOURCE_PATH, "uri", "./contact", REG_SZ
        
        'For Task
        
        SOURCE_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & TASKS
        SetKeyValue SOURCE_PATH, "sync", "none", REG_SZ
        SetKeyValue SOURCE_PATH, "last", "0", REG_SZ
        SetKeyValue SOURCE_PATH, "name", "./task", REG_SZ
        SetKeyValue SOURCE_PATH, "type", "text/plain", REG_SZ
        SetKeyValue SOURCE_PATH, "syncModes", "slow,two-way,refresh", REG_SZ
        SetKeyValue SOURCE_PATH, "uri", "./task", REG_SZ
        
        'For Favorites
        
        SOURCE_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & FAVORITES
        SetKeyValue SOURCE_PATH, "sync", "none", REG_SZ
        SetKeyValue SOURCE_PATH, "last", "0", REG_SZ
        SetKeyValue SOURCE_PATH, "name", "./favorite", REG_SZ
        SetKeyValue SOURCE_PATH, "type", "text/plain", REG_SZ
        SetKeyValue SOURCE_PATH, "syncModes", "slow,two-way,refresh", REG_SZ
        SetKeyValue SOURCE_PATH, "dir", "", REG_SZ
        SetKeyValue SOURCE_PATH, "uri", "./favorite", REG_SZ
        
        ' For Notes
        
        SOURCE_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & NOTES
        SetKeyValue SOURCE_PATH, "sync", "none", REG_SZ
        SetKeyValue SOURCE_PATH, "last", "0", REG_SZ
        SetKeyValue SOURCE_PATH, "name", "./note", REG_SZ
        SetKeyValue SOURCE_PATH, "type", "text/plain", REG_SZ
        'to hidden note elements
        'SetKeyValue SOURCE_PATH, "syncModes", "slow,two-way,refresh", REG_SZ
        SetKeyValue SOURCE_PATH, "syncModes", "none", REG_SZ
        SetKeyValue SOURCE_PATH, "dir", "", REG_SZ
        SetKeyValue SOURCE_PATH, "uri", "./note", REG_SZ
        
        ' For FileBackup
        
        SOURCE_PATH = FUNAMBOL & "\" & SYNCCLIENT & "\" & SPDS & "\" & SOURCES & "\" & FILEBACKUP
        SetKeyValue SOURCE_PATH, "sync", "none", REG_SZ
        SetKeyValue SOURCE_PATH, "last", "0", REG_SZ
        SetKeyValue SOURCE_PATH, "name", "./filebackup", REG_SZ
        SetKeyValue SOURCE_PATH, "type", "text/plain", REG_SZ
        SetKeyValue SOURCE_PATH, "syncModes", "slow,two-way,refresh", REG_SZ
        SetKeyValue SOURCE_PATH, "dir", "", REG_SZ
        SetKeyValue SOURCE_PATH, "uri", "./filebackup", REG_SZ
        
        
        
        
    Else
        'MsgBox "-" & ris & "-", vbOKOnly, "Pieno"
        'nothing to do
    End If
    
    'MsgBox "-" & ret & "-", vbOKOnly, "Saved"
    
    
    
    
End Function
 
  
  'SetValueEx and QueryValueEx Wrapper Functions:
 Public Function SetValueEx(ByVal hkey As Long, _
                           sValueName As String, _
                           lType As Long, vValue As Variant) As Long
       
    Dim lValue As Long
    Dim sValue As String
    
    Select Case lType
        Case REG_SZ
            sValue = vValue & Chr(0)
            SetValueEx = RegSetValueExString(hkey, sValueName, CLng(0), _
                                           lType, CStr(sValue), Len(sValue) * 2)
        Case REG_DWORD
            lValue = vValue
            SetValueEx = RegSetValueExLong(hkey, sValueName, CLng(0), _
                                           lType, CLng(lValue), 4)
    End Select
    
End Function
Public Function CreateNewKey(sNewKeyName As String)
       
Dim hNewKey As Long         '-- Handle to the new key
Dim lRetVal As Long         '-- Result of the RegCreateKeyEx function

'-- Create Registry Key
'-- If key already exists, nothing happens
lRetVal = RegCreateKeyEx(HKEY_LOCAL_MACHINE, sNewKeyName, CLng(0), _
          vbNullString, REG_OPTION_NON_VOLATILE, _
          KEY_ALL_ACCESS, _
          CLng(0), hNewKey, lRetVal)

'-- Return Handle to Key
CreateNewKey = hNewKey

'-- Close Registry Handle
RegCloseKey (hNewKey)

End Function
Public Function QueryValue(sKeyName As String, _
                           sValueName As String)

       Dim lRetVal  As Long         'result of the API functions
       Dim hkey     As Long         'handle of opened key
       Dim vValue   As Variant      'setting of queried value

       '-- Open Registry Key
       lRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sKeyName, 0, _
                KEY_ALL_ACCESS, hkey)
       
       '-- Query Registry Value
       lRetVal = QueryValueEx(hkey, sValueName, vValue)
       
       '-- Return Value
       QueryValue = vValue
       
       '-- Close Reg Key
       RegCloseKey (hkey)

End Function

Public Sub SetKeyValue(sKeyName As String, _
                       sValueName As String, _
                       vValueSetting As Variant, _
                       lValueType As Long)
   
    Dim lRetVal  As Long         '-- Result of the SetValueEx function
    Dim hkey     As Long         '-- Handle of open key
       
    '-- Open the specified key
    lRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sKeyName, _
                           0, _
                           KEY_ALL_ACCESS, hkey)
                              
    '-- Set New Value
    lRetVal = SetValueEx(hkey, sValueName, lValueType, vValueSetting)
    
    '-- Close Reg Key
    RegCloseKey (hkey)
End Sub

Function QueryValueEx(ByVal lhKey As Long, _
                      ByVal szValueName As String, _
                      vValue As Variant) As Long
       
    Dim cch      As Long
    Dim lrc      As Long
    Dim lType    As Long
    Dim lValue   As Long
    Dim sValue   As String

    '-- Determine the size and type of data to be read
    lrc = RegQueryValueEx(lhKey, szValueName, CLng(0), lType, CLng(0), cch)
    
    Select Case lType
        '-- For strings
        Case REG_SZ:
            sValue = String(cch, 0)
            lrc = RegQueryValueExString(lhKey, szValueName, CLng(0), lType, _
                                        sValue, cch)
            If lrc = ERROR_NONE Then
                vValue = Left(sValue, cch - 1)
            Else
                vValue = Empty
            End If
        
        '-- For DWORDS
        Case REG_DWORD:
            lrc = RegQueryValueExLong(lhKey, szValueName, CLng(0), lType, _
                                      lValue, cch)
            If lrc = ERROR_NONE Then vValue = lValue
        Case Else
            '-- All other data types not supported
            lrc = -1
    End Select

End Function

