/*
 * Copyright (C) 200-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/ContactSyncSource.h"
#include "spds/SyncItemStatus.h"
#include "base/util/utils.h"
#include "base/Log.h"
#include "pim/POOMClient2Server.h"
#include "pim/POOMServer2Client.h"


ContactSyncSource::ContactSyncSource(const wchar_t* name, SourceType t) : WindowsSyncSource(name) {
   setSourceType(t);
}

ContactSyncSource::~ContactSyncSource() {
}

void ContactSyncSource::setSourceType(SourceType t) {
    setType(t);
}

ArrayElement* ContactSyncSource::clone() {
    ContactSyncSource* s = new ContactSyncSource(getName(), getType());
    s->setPath(getPath());

    s->assign(*this);

    return s;
}