/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
//

#include <windows.h>
#include "Winbase.h"

#include "pimstore.h"
#include <stdio.h>

#include "base/Log.h"
#include "spds/spdsutils.h"
#include "spds/Constants.h"

#include "spdm/spdmutils.h"

#include "pim/ActionLog.h"
#include "pim/Utils.h"

#include "pim/FILEClient2Server.h"
#include "pim/FILEFileManagement.h"

#include "shellapi.h"

/*
to get My documents foleder
SHGetSpecialFolderPath(NULL, internalPath, CSIDL_PERSONAL, FALSE);

*/

void setAllItemsFILE(Container* c, int dataType, wchar_t* path, wchar_t* dir) {    	        
    
    LOG.debug(TEXT("SLOW: in setAllItems FILE... "));		
    
    wchar_t localTemp [DIM_LOCAL_TEMP];

    wchar_t **ptrArrayOfFileName    = NULL;   
    wchar_t  *ptrFileContent        = NULL;

    wchar_t   filterPattern [256];
    wchar_t   internalPath  [DIM_LOCAL_TEMP];

    int numBytes            = 0;
    int count               = 0;
    int j                   = 0;
    unsigned long sizeFile  = 0;    
    
    BOOL recursiveInDirectory = FALSE;
    filterPattern[0] = 0;
    internalPath[0]  = 0;

    //
    // decide the path of the files to read
    //

    if (dataType == constFiles) 
        wsprintf(internalPath, TEXT("%s%s"), dir, TEXT("\\"));
    else if (dataType == constNotes) {
        wsprintf(internalPath,  TEXT("%s%s"), dir, TEXT("\\"));
        wsprintf(filterPattern, PWI_EXTENSION_PATTERN);
    }
    else if (dataType == constFavorites) {     
        SHGetSpecialFolderPath(NULL, localTemp, CSIDL_FAVORITES, FALSE);
        wsprintf(internalPath, TEXT("%s%s"), localTemp, TEXT("\\"));
        recursiveInDirectory = TRUE;          
    }
   
    // to retrieve num of files
    getFileList(internalPath, ptrArrayOfFileName, &count, TRUE, recursiveInDirectory, filterPattern);    
    
    if (dbg) {
		wsprintf(localTemp, TEXT("AllItems: onlyCount: %i"), count);
		MessageBox (NULL, localTemp, TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
	}

    ptrArrayOfFileName = new wchar_t*[count];

    for ( int k = 0; k < count; k++) {
        ptrArrayOfFileName[k] = 0;
    }
   	
    // to retrieve fileName
    getFileList(internalPath, ptrArrayOfFileName, &count, FALSE, recursiveInDirectory, filterPattern);        
    

   	if (dbg) {
		wsprintf(localTemp, TEXT("AllItems: count: %i"), count);
		MessageBox (NULL, localTemp, TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
	}
    
	// SyncItem** allItems = new SyncItem* [count];

    SyncItem* syncItem = NULL;
	
    for (j = 0; j < count; j++) {
    
        // fileName with complete path (e.g. \\Program Files\\SyncClient PIM\\store\\example.bin)
        wsprintf(localTemp, ptrArrayOfFileName[j]);

        if (dataType == constFiles) {
            ptrFileContent = getB64DataContentByFilename(ptrArrayOfFileName[j]);
            // only file name without path. (e.g. example.bin)
            getFileName(ptrArrayOfFileName[j], localTemp);
        
            
        } else if (dataType == constNotes) {
                        
            ptrFileContent = readTextFromBinaryFile(ptrArrayOfFileName[j]);
            
            // only file name without path. (e.g. example.bin)
            getFileName(ptrArrayOfFileName[j], localTemp);
            
            // to send to the server the xml structure <note><Subject>fileName.pwi</Subject><Body>the body</Body></note>
            if (ptrFileContent != NULL) {
                
                getXMLNote(&ptrFileContent, localTemp);
                translateText2Base64(&ptrFileContent);                

            }
            
        }
        else if (dataType == constFavorites) {
            if (dbg)                       
		        MessageBox (NULL, localTemp, TEXT ("settingAllItems"), MB_SETFOREGROUND |MB_OK);
            
            ptrFileContent = readTextFromBinaryFile(ptrArrayOfFileName[j]);                          

            if (ptrFileContent != NULL) {
                translateText2Base64(&ptrFileContent);                
            }             
            
            wsprintf(localTemp, ptrArrayOfFileName[j]);
            
            wchar_t* t = wcsstr(ptrArrayOfFileName[j], internalPath);            
            
            if (t != NULL) {
                 if (dbg) {	                       
		            MessageBox (NULL, t, TEXT ("settingAllItems"), MB_SETFOREGROUND |MB_OK);	            
	             }   
                wsprintf(localTemp, t + wcslen(internalPath));
                delete t;
            }
            if (FILE_SYSTEM_SYNC_SOURCE == TRUE)
                convertSlashAt(localTemp);

        }
        
        if (dbg) {	                       
		    MessageBox (NULL, localTemp, TEXT ("File name in settingAllItems"), MB_SETFOREGROUND |MB_OK);	            
	    }    
        
        encodeKey (localTemp);
        // allItems[j] = new SyncItem(localTemp);	                
        syncItem = new SyncItem(localTemp);	                

        if (ptrFileContent == NULL) {
            // allItems[j]->setData(TEXT(""), 1*sizeof(wchar_t));	
            syncItem->setData(TEXT(""), 1*sizeof(wchar_t));	
        }
        else {
            // allItems[j]->setData(ptrFileContent, (wcslen(ptrFileContent) + 1)*sizeof(wchar_t));	
            syncItem->setData(ptrFileContent, (wcslen(ptrFileContent) + 1)*sizeof(wchar_t));	
        }
        
        c->addItemToAllItems(syncItem);

        if (ptrFileContent != NULL) {
            delete ptrFileContent; ptrFileContent = NULL;
        }
        if (syncItem) {
            delete syncItem; syncItem = NULL;
        }

	}

    // delete array and pointer...
    for (j = 0; j < count; j++) {
        if (ptrArrayOfFileName[j] != NULL)
            delete ptrArrayOfFileName[j]; 
    }

    if (ptrArrayOfFileName != NULL)
        delete [] ptrArrayOfFileName;
    	
	wsprintf(localTemp, SET_ALL_ITEMS, count); 
	LOG.debug(TEXT("Exiting from setAllItems... "));

    
}

void setAllItemsFILEKey(Container* c, int dataType, wchar_t* path, wchar_t* dir) {    	        		
    
    wchar_t localTemp [DIM_LOCAL_TEMP];

    wchar_t **ptrArrayOfFileName    = NULL;   
   

    wchar_t   filterPattern [256];
    wchar_t   internalPath  [DIM_LOCAL_TEMP];

    int numBytes            = 0;
    int count               = 0;
    int j                   = 0;
    unsigned long sizeFile  = 0;    
    
    BOOL recursiveInDirectory = FALSE;
    filterPattern[0] = 0;
    internalPath[0]  = 0;

    //
    // decide the path of the files to read
    //

    if (dataType == constFiles) 
        wsprintf(internalPath, TEXT("%s%s"), dir, TEXT("\\"));
    else if (dataType == constNotes) {
        wsprintf(internalPath,  TEXT("%s%s"), dir, TEXT("\\"));
        wsprintf(filterPattern, PWI_EXTENSION_PATTERN);
    }
    else if (dataType == constFavorites) {     
        SHGetSpecialFolderPath(NULL, localTemp, CSIDL_FAVORITES, FALSE);
        wsprintf(internalPath, TEXT("%s%s"), localTemp, TEXT("\\"));
        recursiveInDirectory = TRUE;          
    }
   
    // to retrieve num of files
    getFileList(internalPath, ptrArrayOfFileName, &count, TRUE, recursiveInDirectory, filterPattern);    
    
    ptrArrayOfFileName = new wchar_t*[count];

    for ( int k = 0; k < count; k++) {
        ptrArrayOfFileName[k] = 0;
    }
   	
    // to retrieve fileName
    getFileList(internalPath, ptrArrayOfFileName, &count, FALSE, recursiveInDirectory, filterPattern);        

    SyncItem* syncItem = NULL;
	
    for (j = 0; j < count; j++) {
    
        // fileName with complete path (e.g. \\Program Files\\SyncClient PIM\\store\\example.bin)
        wsprintf(localTemp, ptrArrayOfFileName[j]);

        if (dataType == constFiles) 
            getFileName(ptrArrayOfFileName[j], localTemp);
        else if (dataType == constNotes)
            getFileName(ptrArrayOfFileName[j], localTemp);
        else if (dataType == constFavorites) {
                                    
            wsprintf(localTemp, ptrArrayOfFileName[j]);
            
            wchar_t* t = wcsstr(ptrArrayOfFileName[j], internalPath);            
            
            if (t != NULL) {
                 if (dbg) {	                       
		            MessageBox (NULL, t, TEXT ("settingAllItems"), MB_SETFOREGROUND |MB_OK);	            
	             }   
                wsprintf(localTemp, t + wcslen(internalPath));
                delete t;
            }
            if (FILE_SYSTEM_SYNC_SOURCE == TRUE)
                convertSlashAt(localTemp);
        }
        
        encodeKey (localTemp);
    	                
        syncItem = new SyncItem(localTemp);	                
        syncItem->setData(TEXT(""), 1*sizeof(wchar_t));	
      
        c->addItemToAllItems(syncItem);

        if (syncItem) {
            delete syncItem; syncItem = NULL;
        }

	}

    // delete array and pointer...
    for (j = 0; j < count; j++) {
        if (ptrArrayOfFileName[j] != NULL)
            delete ptrArrayOfFileName[j]; 
    }

    if (ptrArrayOfFileName != NULL)
        delete [] ptrArrayOfFileName;  
}

/*
* The method replace the text file content with new one in xml format.
*/
void getXMLNote (wchar_t** ptrFileContent, wchar_t* fileName) {

    wchar_t* t  = NULL;
    wchar_t  fileNameNoPwiExt [DIM_LOCAL_TEMP];
    string s = string();
    int position = 0;
    
    string element_s = string();
    string key_s = string();

    element_s = string(*ptrFileContent); 
    encodeSpecialChar(element_s);    

    wsprintf(fileNameNoPwiExt, fileName);
       
    s += (wchar_t*)fileNameNoPwiExt;
    position = pos(PWI_EXTENSION, s);
    if (position != -1) {
        fileNameNoPwiExt[position] = 0;
        s = string((wchar_t*)fileNameNoPwiExt);
    }       
    encodeSpecialChar(s); 
    
    wchar_t tempDate[64];
    doubleToSystemTime(tempDate, getSystemTime());

    // t = new wchar_t [250 + wcslen(*ptrFileContent)];
    t = new wchar_t [250 + length(element_s)];
    t[0] = 0;
    wcscat(t, TEXT("<?xml version=\"1.0\" encoding=\"UTF-8\"?><note><Subject>"));
    // wcscat(t, fileNameNoPwiExt); // filename (with no .pwi extension)
    wcscat(t, (wchar_t*)s); // filename (with no .pwi extension)
    wcscat(t, TEXT("</Subject><Body>"));
    // wcscat(t, *ptrFileContent);
    wcscat(t, (wchar_t*)element_s);
    wcscat(t, TEXT("</Body><Date>"));
    wcscat(t, tempDate);
    wcscat(t, TEXT("</Date></note>"));
    
    



    delete *ptrFileContent;

    *ptrFileContent = t;     
}

/*
* text pointed by ptrData is translated in base64 and assigned to ptrData
* 
*/
void translateText2Base64(wchar_t** ptrFileContent) {
    
    wchar_t* ptr = NULL;
    ptr = encodeBase64UTF8(*ptrFileContent);    
    if (*ptrFileContent != NULL) {
        delete *ptrFileContent; 
        *ptrFileContent = NULL;
    }
    *ptrFileContent = ptr;
    
    /*
    //
    // Used before introduction of UTF-8 charset
    //
    char* loc = wchar2char(*ptrFileContent);
    int len = 0, encodeLen = 0; 
    len = strlen(loc);
    encodeLen = lengthForB64(len);
    char* base64 = new char[encodeLen + 1];
    memset(base64, 0, encodeLen + 1);
    encodeBase64(loc, base64, len);
    delete *ptrFileContent; *ptrFileContent = NULL;
    delete loc; loc = NULL;
    *ptrFileContent = char2wchar(base64); 
    delete base64; base64 = NULL;
    */
}


/*
* get the data content of a file by filename and return these data into base64 format.
* It's useful to read data to set into setAllItems, setModifiedItem, setNewItems
*/


wchar_t* getB64DataContentByFilename(wchar_t* filename) {

    unsigned long sizeFile      = 0;
    int      numBytes           = 0;
    byte*    ptrFileContent     = NULL;    
    char*    base64             = NULL;
    wchar_t* ptrFileContentb64  = NULL;
    int encodeLen               = 0; 
    getFileSize(filename, &sizeFile);

    if (sizeFile == 0)
        goto finally;

    ptrFileContent = new byte[sizeFile]; 

    // read bytes from file

    readByteFromFile(filename, ptrFileContent, &numBytes);

    if (numBytes != (int)sizeFile) {
        if (dbg) {		            
		    MessageBox (NULL, TEXT("sizeFile and numBytes are different"), TEXT ("getB64DataContentByFilename"), MB_SETFOREGROUND |MB_OK);            
	    }
        goto finally;
    }		    

    encodeLen = lengthForB64(numBytes); 
    base64 = new char[encodeLen + 1];

    if (base64 == NULL) {
        LOG.info(TEXT("not enough memory to instantiate array..."));
    }

    memset(base64, 0, encodeLen + 1);
    
    b64_encode(base64, ptrFileContent, numBytes);      
    
    // encodeBase64(ptrFileContent, base64, numBytes);

    if (dbg) {	    
        wchar_t t[10]; wsprintf(t, TEXT("%i"), strlen(base64));		    
        MessageBox (NULL, t, TEXT ("getB64DataContentByFilename len"), MB_SETFOREGROUND |MB_OK);	            
    }

    // transform char into wchar...
    // ptrFileContentb64 = char2wchar(base64);     
    ptrFileContentb64 = utf82wc(base64);
 
finally:

    if (ptrFileContent != NULL)
        delete ptrFileContent; ptrFileContent = NULL;
    if (base64 != NULL)
        delete base64; base64 = NULL;
    
    return ptrFileContentb64;
}



/*
* Method to understand if file are new, deleted or updated.
*/

void setModifiedItemsFILE(Container* c, int dataType, wchar_t* path, wchar_t* dir) {

    LOG.debug(TEXT("TWO-WAY: in setModifiedItems FILE... "));		
    
    wchar_t   localTemp     [DIM_LOCAL_TEMP];    
    wchar_t   internalPath  [DIM_LOCAL_TEMP];
    wchar_t   filterPattern [DIM_LOCAL_TEMP];
    wchar_t   wtime         [DIM_LOCAL_TEMP]; 
    
    localTemp[0]        = 0;
    internalPath[0]     = 0;
    wtime[0]            = 0;
    filterPattern[0]    = 0;

    wchar_t** ptrFilenameInDir      = NULL;   
    wchar_t*  ptrFileContent        = NULL;        

    wchar_t** ptrFilenameFromFile   = NULL;
   

    // SyncItem** newItems;
	// SyncItem** updatedItems;    
	// SyncItem** deletedItems;
    SyncItem* syncItem = NULL;

    int numBytes            = 0;    
    int countFileInDir      = 0;
    int countFileInFile     = 0;
    int countNewItems       = 0;
    int countUpdatedItems   = 0;
    int countDeletedItems   = 0;

    int j                   = 1;
    int i                   = 0;
    unsigned long sizeFile  = 0;    
    DATE dtime              = 0.0;
    DATE timeInFile         = 0.0;
         
    BOOL found = FALSE;
    BOOL recursiveInDirectory = FALSE;
    
    filterPattern[0] = 0;
    
    string key_s = string();

    if (dataType == constFiles)
        wsprintf(internalPath, TEXT("%s%s"), dir, TEXT("\\"));
    else if (dataType == constNotes) {
        wsprintf(internalPath, TEXT("%s%s"), dir, TEXT("\\"));
        wsprintf(filterPattern, PWI_EXTENSION_PATTERN);
    }
    else if (dataType == constFavorites) {        
        SHGetSpecialFolderPath(NULL, internalPath, CSIDL_FAVORITES, FALSE);
        wcscat(internalPath, TEXT("\\"));    
        recursiveInDirectory = TRUE;    
    }

    // to retrieve num of files in directory
    getFileList(internalPath, ptrFilenameInDir, &countFileInDir, TRUE, recursiveInDirectory, filterPattern);    
    ptrFilenameInDir = new wchar_t*[countFileInDir];
   	
    // to retrieve fileName
    getFileList(internalPath, ptrFilenameInDir, &countFileInDir, FALSE, recursiveInDirectory, filterPattern);        
    
   	if (dbg) {
		wsprintf(localTemp, TEXT("setModifiedItemsFILE: count: %i"), countFileInDir);
		MessageBox (NULL, localTemp, TEXT ("countFileInDir"), MB_SETFOREGROUND |MB_OK);
	}    
    
    // to retrieve num of files in files.dat/notes.dat
    countFileInFile = readFilenameFromFile(dataType, path, &ptrFilenameFromFile);
    
    if (dbg) {
		wsprintf(localTemp, TEXT("setModifiedItemsFILE: count: %i"), countFileInFile);
		MessageBox (NULL, localTemp, TEXT ("countFileInFile"), MB_SETFOREGROUND |MB_OK);        
	} 
    
    // first element in file is timestamp
    timeInFile = wcstod(ptrFilenameFromFile[0], NULL);

    if (dbg) {
		wsprintf(localTemp, TEXT("setModifiedItemsFILE: count: %f"), timeInFile);
		MessageBox (NULL, localTemp, TEXT ("timeInFile"), MB_SETFOREGROUND |MB_OK);        
	} 
    
    // max num new or updated items is countFileInDir
    /*
    if (countFileInDir > 0) {
        newItems     = new SyncItem* [countFileInDir ];
	    updatedItems = new SyncItem* [countFileInDir ];
    }
    // max num new or updated items is countFileInFile
    if (countFileInFile > 0) 
        deletedItems = new SyncItem* [countFileInFile];
    
    for (i = 0; i < countFileInDir ; i++) {
	    newItems[i]     = NULL; // every newItems     pointer initialized to null!
        updatedItems[i] = NULL; // every updatedItems pointer initialized to null!
    }
     for (i = 0; i < countFileInFile ; i++) {
	    deletedItems[i] = NULL; // every deletedItems pointer initialized to null!       
    }
    */
    //
    // to get the new or update items that are files
    //    
   
    for (i = 0; i < countFileInDir; i++) {   
        
        found = FALSE;

        for (j = 1; j <= countFileInFile; j++) {                              

            if (wcscmp(ptrFilenameInDir[i], ptrFilenameFromFile[j]) == 0) {            
            
                found = TRUE;
                getLastWriteTime(ptrFilenameInDir[i], wtime, &dtime);
                
                if (dtime > timeInFile) {
                    
                    if (dbg) {
                        MessageBox (NULL, TEXT("Update file"), TEXT ("Update"), MB_SETFOREGROUND |MB_OK); 
                    }    
                        if (dataType == constFiles) {
                            ptrFileContent = getB64DataContentByFilename(ptrFilenameInDir[i]);
                            // only file name without path. (e.g. example.bin)
                            getFileName(ptrFilenameInDir[i], localTemp);
                        }
                        else if (dataType == constNotes) {            
                            ptrFileContent = readTextFromBinaryFile(ptrFilenameInDir[i]);
                            
                             // only file name without path. (e.g. example.bin)
                            getFileName(ptrFilenameInDir[i], localTemp);

                            if (ptrFileContent != NULL) {
                               
                                getXMLNote(&ptrFileContent, localTemp);
                                translateText2Base64(&ptrFileContent);           
                                
                            }
                           
                        }
                        else if (dataType == constFavorites) {
                            ptrFileContent = readTextFromBinaryFile(ptrFilenameInDir[i]);
                            
                            if (ptrFileContent != NULL) {
                                translateText2Base64(&ptrFileContent);                
                            }

                            wsprintf(localTemp, ptrFilenameInDir[i]);                            

                            wchar_t* t = wcsstr(ptrFilenameInDir[i], internalPath);            
                            if (t != NULL) {
                                 if (dbg) {	                       
		                            MessageBox (NULL, t, TEXT ("settingModItems"), MB_SETFOREGROUND |MB_OK);	            
	                             }   
                                wsprintf(localTemp, t + wcslen(internalPath));
                            }
                            if (FILE_SYSTEM_SYNC_SOURCE == TRUE)
                                convertSlashAt(localTemp);

                        }                        
                            
                        if (dbg) {	                       
		                    MessageBox (NULL, localTemp, TEXT ("File name in updateItems"), MB_SETFOREGROUND |MB_OK);	            
	                    }                        
                        encodeKey (localTemp);
                        key_s = string(localTemp);
                        encodeSpecialChar(key_s);                        
                        
                        // updatedItems[countUpdatedItems] = new SyncItem((wchar_t*)key_s);	
                        syncItem = new SyncItem((wchar_t*)key_s);	

                        // without CDATA
        
                        if (ptrFileContent == NULL) {
                            // updatedItems[countUpdatedItems]->setData(TEXT(""), 1*sizeof(wchar_t));	
                            syncItem->setData(TEXT(""), 1*sizeof(wchar_t));	
                        }
                        else {
                            // updatedItems[countUpdatedItems]->setData(ptrFileContent, (wcslen(ptrFileContent) + 1)*sizeof(wchar_t));	                        
                            syncItem->setData(ptrFileContent, (wcslen(ptrFileContent) + 1)*sizeof(wchar_t));	                        
                            
                        }
                        countUpdatedItems++;
                        
                        c->addItemToUpdatedItems(syncItem);

                        if (syncItem)
                            delete syncItem;
                        syncItem = NULL;

                        if (ptrFileContent != NULL)
                            delete ptrFileContent; 
                        ptrFileContent = NULL;

                }
                else {
                    if (dbg) {
                        MessageBox (NULL, TEXT("Nothing to do"), TEXT ("Nothing"), MB_SETFOREGROUND |MB_OK); 
                    }
                }
                break;
            }

        }

        if (found == FALSE) {
            if (dbg) {
                MessageBox (NULL, TEXT("New"), TEXT ("New"), MB_SETFOREGROUND |MB_OK); 
            }

            if (dataType == constFiles) {
                ptrFileContent = getB64DataContentByFilename(ptrFilenameInDir[i]);
                getFileName(ptrFilenameInDir[i], localTemp);
            }
            else if (dataType == constNotes) {            
                ptrFileContent = readTextFromBinaryFile(ptrFilenameInDir[i]);
                
                getFileName(ptrFilenameInDir[i], localTemp);

                if (ptrFileContent != NULL) {
                   
                    getXMLNote(&ptrFileContent, localTemp);
                    translateText2Base64(&ptrFileContent);                         
                }                
            }
            else if (dataType == constFavorites) {
                ptrFileContent = readTextFromBinaryFile(ptrFilenameInDir[i]);

                if (ptrFileContent != NULL) {
                    translateText2Base64(&ptrFileContent);                
                }

                wsprintf(localTemp, ptrFilenameInDir[i]);

                wchar_t* t = wcsstr(ptrFilenameInDir[i], internalPath);            
                if (t != NULL) {
                     if (dbg) {	                       
		                MessageBox (NULL, t, TEXT ("settingModItems"), MB_SETFOREGROUND |MB_OK);	            
	                 }   
                     wsprintf(localTemp, t + wcslen(internalPath));
                }
                if (FILE_SYSTEM_SYNC_SOURCE == TRUE)
                    convertSlashAt(localTemp);

            }
            if (dbg) {	                       
		        MessageBox (NULL, ptrFileContent, TEXT ("ptrFileContentb64"), MB_SETFOREGROUND |MB_OK);	            
	        }            

            if (dbg) {	                       
		        MessageBox (NULL, localTemp, TEXT ("File name in new Items"), MB_SETFOREGROUND |MB_OK);	            
	        }
            encodeKey (localTemp);
            key_s = string(localTemp);
            encodeSpecialChar(key_s);
            
            // newItems[countNewItems] = new SyncItem((wchar_t*)key_s);
            syncItem = new SyncItem((wchar_t*)key_s);
            

            // without CDATA
        
            if (ptrFileContent == NULL) {
                // newItems[countNewItems]->setData(TEXT(""), 1*sizeof(wchar_t));	
                syncItem->setData(TEXT(""), 1*sizeof(wchar_t));	
            }
            else {
                // newItems[countNewItems]->setData(ptrFileContent, (wcslen(ptrFileContent) + 1)*sizeof(wchar_t));	                        
                syncItem->setData(ptrFileContent, (wcslen(ptrFileContent) + 1)*sizeof(wchar_t));	                        
                
            }
            countNewItems++;
            
            c->addItemToNewItems(syncItem);

            if (syncItem) 
                delete syncItem;
            syncItem = NULL;
           
            if (ptrFileContent != NULL)
                delete ptrFileContent; 
            ptrFileContent = NULL;            

        }

    }
    
    //
    // to get the delete items that are files
    //

    for (j = 1; j <= countFileInFile; j++) {

        found = FALSE;
        for (i = 0; i < countFileInDir; i++) {                        
            if (wcscmp( ptrFilenameFromFile[j], ptrFilenameInDir[i]) == 0) {
                found = TRUE;               
            }
        }        
        if (found == TRUE) {
            if (dbg) {
                MessageBox (NULL, TEXT("Found: nothing to do"), TEXT ("Found"), MB_SETFOREGROUND |MB_OK); 
            }
        }
        else {

            if (dbg) {
                MessageBox (NULL, TEXT("Delete"), TEXT ("Delete"), MB_SETFOREGROUND |MB_OK); 
            }

            if (dataType == constFiles || dataType == constNotes) {
                getFileName(ptrFilenameFromFile[j], localTemp);
            }
            else if (dataType == constFavorites) {                
                wsprintf(localTemp, ptrFilenameFromFile[j]);
                wchar_t* t = wcsstr(ptrFilenameFromFile[j], internalPath);         
                if (t != NULL) {
                     if (dbg) {	                       
		                MessageBox (NULL, t, TEXT ("settingDelItems"), MB_SETFOREGROUND |MB_OK);	            
	                 }   
                    wsprintf(localTemp, t + wcslen(internalPath));
                }
                if (FILE_SYSTEM_SYNC_SOURCE == TRUE)
                    convertSlashAt(localTemp);

            }

            if (dbg) {	                       
		        MessageBox (NULL, localTemp, TEXT ("File name in del Items"), MB_SETFOREGROUND |MB_OK);	            
	        }
            encodeKey (localTemp);
            key_s = string(localTemp);
            encodeSpecialChar(key_s);
            
            // deletedItems[countDeletedItems] = new SyncItem((wchar_t*)key_s);	 
            syncItem = new SyncItem((wchar_t*)key_s);	 
            
            c->addItemToDeletedItems(syncItem);

            if (syncItem)
                delete syncItem;
            syncItem = NULL;

            countDeletedItems++;

        }
    }

    
    // delete array and pointer...
    for (j = 0; j < countFileInDir; j++) {
        if (ptrFilenameInDir[j] != NULL)
            delete ptrFilenameInDir[j]; 
    }
    if (ptrFilenameInDir != NULL)
        delete [] ptrFilenameInDir;

    for (j = 0; j < countFileInFile; j++) {
        if (ptrFilenameFromFile[j] != NULL)
            delete ptrFilenameFromFile[j]; 
    }
    if (ptrFilenameFromFile != NULL)
        delete [] ptrFilenameFromFile;    
        
}

