/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// difftime.cpp : Windows SYSTEMTIME diffing functions.
//

#include <windows.h>
#include "notify.h"

#if 0
// Example code

#ifdef _WIN32_WCE
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nShowCmd ) {
#else
int main(int argc, char** argv) {
#endif    
    
    SYSTEMTIME t;
    SYSTEMTIME s1;
    GetLocalTime (&t);

    wchar_t buff[100];
    s1= DT_AddDiff(nano100SecInMin, 1,&t); //diff 1 minute from s2
 
     /*WinAPI function GetDateFormat uses for receive string with 
       datetime in specifid format*/
    // Original day and minute
    GetDateFormat
     (
      LOCALE_USER_DEFAULT,
      NULL,
      &t,
      TEXT("yyyy MM dd"), //my format
      buff,
      100
     );
     //wsprintf(buff, TEXT("original date: %s") ,buff); 
     MessageBox (NULL, buff, TEXT ("!!"), MB_SETFOREGROUND |MB_OK);

     GetTimeFormat
     (
      LOCALE_USER_DEFAULT,
      NULL,
      &t,
      TEXT("HH:mm:ss"), //my format
      buff,
      100
     );
     //wsprintf(buff, TEXT("original time: %s") ,buff); 
     MessageBox (NULL, buff, TEXT ("!!"), MB_SETFOREGROUND |MB_OK);
     
    
    
     // minus a minute and minute
    GetDateFormat
     (
      LOCALE_USER_DEFAULT,
      NULL,
      &s1,
      TEXT("yyyy MM dd"), //my format
      buff,
      100
     );
     
     //wsprintf(buff, TEXT("modified date: %s") ,buff); 
     MessageBox (NULL, buff, TEXT ("!!"), MB_SETFOREGROUND |MB_OK);
    

      GetTimeFormat
     (
      LOCALE_USER_DEFAULT,
      NULL,
      &s1,
      TEXT("HH:mm:ss"), //my format
      buff,
      100
     );
     //wsprintf(buff, TEXT("modified time: %s") ,buff); 
     MessageBox (NULL, buff, TEXT ("!!"), MB_SETFOREGROUND |MB_OK);
    
    
    //MessageBox (NULL, TEXT("start"), TEXT ("!!"), MB_SETFOREGROUND |MB_OK);
    CeRunAppAtTime(TEXT("startservice.exe"), &s1);  

              
    return 0;
 }
#endif



const __int64 nano100SecInWeek=(__int64)10000000*60*60*24*7;
const __int64 nano100SecInDay=(__int64)10000000*60*60*24;
const __int64 nano100SecInHour=(__int64)10000000*60*60;
const __int64 nano100SecInMin=(__int64)10000000*60;
const __int64 nano100SecInSec=(__int64)10000000; 
  
/*1. Diffence BETWEEN two datetime 
////////////
//equivalent of DATEDIFF function from SQLServer
//Returns the number of date and time boundaries crossed 
//between two specified dates. 
//////////// */
double DT_PeriodsBetween (
             const __int64 datepart, /*datepart that we want to count, nano100SecInDay ...}*/
             const SYSTEMTIME* pst1, /*valid datetime*/
             const SYSTEMTIME* pst2  /*valid datetime*/
 ) {
     FILETIME ft1,ft2;
     __int64 *pi1,*pi2;
 
     /*convert SYSTEMTIME to FILETIME
     //SYSTEMTIME is only representation, so need convert to 
     //FILETIME for make some calculation*/
     SystemTimeToFileTime (pst1,&ft1);
     SystemTimeToFileTime (pst2,&ft2); 
     /*convert FILETIME to __int64
     //FILETIME is struct with two DWORD, for receive 
     //ability calculation we must reference to FILETIME as to int*/
     pi1 = (__int64*)&ft1;
     pi2 = (__int64*)&ft2; 
     /*compare two datetimes and (bigger date - smaller date)/period*/
     return (CompareFileTime(&ft1,&ft2)==1) ? 
        (((*pi1)-(*pi2))/(double)datepart) : (((*pi2)-(*pi1))/(double)datepart);
} 
  
/*2. Add/Subtract weeks,days,hours... to/from datetime 
    //and receiving new datetime. 
////////////
//equivalent of DATEADD function from SQLServer
//Returns a new datetime value based on adding an interval
// to the specified date.
/////////// */
SYSTEMTIME DT_AddDiff (
        const __int64 datepart, /*datepart with we want to manipulate, {nano100SecInDay ...}*/
        const __int64 num, /*value used to increment/decrement datepart*/
        const SYSTEMTIME* pst /*valid datetime which we want change*/
 ) {
     FILETIME ft;
     SYSTEMTIME st;
     __int64* pi; 

     SystemTimeToFileTime (pst,&ft); 
     pi = (__int64*)&ft; 
     (*pi) += (__int64)num*datepart; 

     /*convert FAILETIME to SYSTEMTIME*/
     FileTimeToSystemTime (&ft,&st); 

     /*now, st contain new valid datetime, so return it*/
     return st;
} 

