/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "base/util/utils.h"
#include "pim/mail/MailClientData.h"

MailClientData::MailClientData() {
     initialize();
}

MailClientData::~MailClientData() {   
    safeDelete(&folder);
    delete emailData;
    emailData = NULL;
}

void MailClientData::initialize() {
    folder = NULL;
    emailData = new EmailData();

}


void MailClientData::setEmailData(EmailData* t) {
    if (emailData) {
        delete emailData;
    }
    emailData = (EmailData*)t->clone();
}

EmailData* MailClientData::getEmailData() {
    return emailData;
}

void MailClientData::setParent(wchar_t* t) {
    safeDelete(&folder);
    folder = stringdup(t);
}

wchar_t* MailClientData::getParent() {
    return folder;
}
