/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/mail/MailExtraData.h"

MailExtraData::MailExtraData() {
    initialize();   
}

MailExtraData::~MailExtraData() {
    safeDelete(&id);    
    safeDelete(&messageId);    
}

void MailExtraData::initialize() {
    id = NULL;
    messageId = NULL;
    
}

void MailExtraData::setId(wchar_t* t) {
    safeDelete(&id);
    id = stringdup(t);
}

wchar_t* MailExtraData::getId() {
    return id;
}

void MailExtraData::setMessageId(wchar_t* t) {
    safeDelete(&messageId);
    messageId = stringdup(t);
}

wchar_t* MailExtraData::getMessageId() {
    return messageId;
}

ArrayElement* MailExtraData::clone() {
    MailExtraData* ret = new MailExtraData();
    ret->setId(id);
    ret->setMessageId(messageId);
    return ret;
}