/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pim/mail/MailItem.h"

MailItem::MailItem() {
    initialize();   
}

MailItem::~MailItem() {
    safeDelete(&id);    
}

void MailItem::initialize() {
    id = NULL;
    read = FALSE;
}

void MailItem::setId(wchar_t* t) {
    safeDelete(&id);
    id = stringdup(t);
}

wchar_t* MailItem::getId() {
    return id;
}

void MailItem::setRead(wchar_t* t) {
    read = wcstol(t, NULL, 0);    
}

void MailItem::setRead(BOOL t) {
    read = t;
}

BOOL MailItem::getRead() {
    return read;
}

void MailItem::setFolder(wchar_t* t) {
    safeDelete(&folder);
    folder = stringdup(t);
}

wchar_t* MailItem::getFolder() {
    return folder;
}

ArrayElement* MailItem::clone() {
    MailItem* ret = new MailItem();
    ret->setId(id);
    ret->setRead(read);
    return ret;
}