/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
//

#ifndef INCL_APPOINTMENT_BUILDER
#define INCL_APPOINTMENT_BUILDER
    
    #include "pimstore.h"
    #include "pim/Utils.h"
    #include "pim/crc32.h"
	#include "ptypes/ptypes.h"
	#include "vocl/VObject.h"
    
    USING_PTYPES
    
        void populateAppointmentStringItem(string &appointmentStringItem, IAppointment *pAppointment);
        void completeAppointment(IAppointment *pAppointment, wchar_t *ptrData);
        void normalizeAppointment(IPOutlookApp *polApp, int dataType);
        long calculateAppointmentHash (IAppointment* pAppointment);
        BOOL isAllDayEvent(DATE start, DATE end);
        BOOL isDateForAllDayEventFormat(wchar_t* stringDate);
		VObject* AppointmentToVObject(IAppointment *pAppointment);
		void VObjectToAppointment(IAppointment *pAppointment, VObject *vo);
		long calculateDayOfWeek(wchar_t* in);
		bool isDayOfWeek(wchar_t* string);
		long getWeekDay(DATE dt);
		wchar_t* extractDayOfWeek(long l);

#endif