/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_NOTE_SYNC_SOURCE
#define INCL_NOTE_SYNC_SOURCE

#include "base/fscapi.h"
#include "spds/constants.h"
#include "base/util/ArrayElement.h"
#include "spds/SyncItem.h"
#include "spds/SyncMap.h"
#include "spds/SyncStatus.h"
#include "pim/FileObjectSyncSource.h"
#include "pim/Container.h"

class /*__declspec(dllexport)*/ NoteSyncSource : public FileObjectSyncSource {
       
public:
        
    /*
    * retrieves the dir parameter set by user in which there are the notes to sync
    */
    void setDirFromDM();
    
    /**
     * Constructor: create a SyncSource with the specified name
     *
     * @param name - the name of the SyncSource
     */
    NoteSyncSource(const wchar_t* name, SourceType t);
    
    void setSourceType(SourceType t);    
    
    ~NoteSyncSource();
    
    ArrayElement* clone();
    
};

#endif
