/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
//

#ifndef INCL_SETTINGSFUNCTIONS
    #define INCL_SETTINGSFUNCTIONS    
   
    #include "pim/Utils.h"
    
    #define PROPERTY_SPDM_REMOTE_SETTINGS   TEXT("spdm.showRemoteSettings") 
    #define PROPERTY_REMOTE_SETTINGS        TEXT("showRemoteSettings") 

    //used in Utils to determine if SystemTimeUTC or LocaTime conversion
    // 0 no conversion applied
    // 1 conversion applied

    //#define PROPERTY_SOURCEPROP_SPDM_SYSTEMTIME_TO_LOCALTIME   TEXT("spdm.adjustSystemTimeToLocalTime") 
    //#define PROPERTY_SOURCEPROP_SYSTEMTIME_TO_LOCALTIME        TEXT("adjustSystemTimeToLocalTime") 
    
    #define PROPERTY_SPDM_LOG_LEVEL   TEXT("spdm.logLevel") 
    #define PROPERTY_LOG_LEVEL        TEXT("logLevel") 
    
    #define PROPERTY_SPDM_ENCRYPT   TEXT("spdm.enctypt") 
    #define PROPERTY_ENCRYPT        TEXT("encrypt") 
    
    #define PROPERTY_SPDM_PATH_INFO  TEXT("spdm.path")
    #define PROPERTY_PATH_INFO  TEXT("path")
    
    #define PROPERTY_SPDM_PUSH_NOTIFICATION  TEXT("spdm.push")
    #define PROPERTY_PUSH_NOTIFICATION       TEXT("push")
    
    #define PROPERTY_SPDM_POLLING_NOTIFICATION  TEXT("spdm.polling")
    #define PROPERTY_POLLING_NOTIFICATION       TEXT("polling")
    
    #define PROPERTY_SPDM_SERVER_NOTIFIED  TEXT("spdm.svrNotified")
    #define PROPERTY_SERVER_NOTIFIED       TEXT("svrNotified")
    

    #define PROPERTY_SOURCEPROP_SPDM_SHOW   TEXT("spdm.show") 
    #define PROPERTY_SOURCEPROP_SHOW        TEXT("show") 
    
    #define PROPERTY_SOURCE_SPDM_USE_SIF   TEXT("spdm.useSIF") 
    #define PROPERTY_SOURCEPROP_USE_SIF        TEXT("useSIF") 
    
    #define PROPERTY_SOURCE_SPDM_SYNC        TEXT("spdm.sync"     )
    #define PROPERTY_SOURCE_SPDM_DIR         TEXT("spdm.dir"      )
    #define PROPERTY_SOURCE_SPDM_URI         TEXT("spdm.uri"      )
    #define PROPERTY_SOURCE_SPDM_SYNC_MODES  TEXT("spdm.syncModes")
    #define PROPERTY_SOURCE_SPDM_LAST        TEXT("spdm.last"     )

    #define CONTEXT_SPDS_SOURCESPROP TEXT("spds/sourcesprop")

    #define DIM_MANAGEMENT_PATH 512
    #define DIM_DEVICE_ID       50

    #define ROOT_CONTEXT            TEXT("Funambol/SyncclientPIM")
    #define SPDS_CONTEXT            TEXT("Funambol/SyncclientPIM/spds/syncml")
    #define APPOINTMENTS_CONTEXT    TEXT("Funambol/SyncclientPIM/spds/sources/appointments")
    #define CONTACTS_CONTEXT        TEXT("Funambol/SyncclientPIM/spds/sources/contacts")
    #define TASKS_CONTEXT           TEXT("Funambol/SyncclientPIM/spds/sources/tasks")
    #define FAVORITES_CONTEXT       TEXT("Funambol/SyncclientPIM/spds/sources/favorites")
    #define NOTES_CONTEXT           TEXT("Funambol/SyncclientPIM/spds/sources/notes")
    #define BRIEFCASE_CONTEXT       TEXT("Funambol/SyncclientPIM/spds/sources/briefcase")
    #define MAILS_CONTEXT           TEXT("Funambol/SyncclientPIM/spds/sources/mails")
    
    #define SOURCES_CONTEXT         TEXT("Funambol/SyncclientPIM/spds/sources")

    #define NOTES_SOURCEPROP_CONTEXT           TEXT("Funambol/SyncclientPIM/spds/sourcesprop/notes")
    #define BRIEFCASE_SOURCEPROP_CONTEXT       TEXT("Funambol/SyncclientPIM/spds/sourcesprop/briefcase")
    #define APPOINTMENTS_SOURCEPROP_CONTEXT    TEXT("Funambol/SyncclientPIM/spds/sourcesprop/appointments")
    #define CONTACTS_SOURCEPROP_CONTEXT        TEXT("Funambol/SyncclientPIM/spds/sourcesprop/contacts")
    #define TASKS_SOURCEPROP_CONTEXT           TEXT("Funambol/SyncclientPIM/spds/sourcesprop/tasks")
    #define FAVORITES_SOURCEPROP_CONTEXT       TEXT("Funambol/SyncclientPIM/spds/sourcesprop/favorites")
    #define MAILS_SOURCEPROP_CONTEXT           TEXT("Funambol/SyncclientPIM/spds/sourcesprop/mails")
    
    #define PROPERTY_SOURCE_DIR     TEXT("dir")
    
    #define PROPERTY_SOURCE_SPDM_INBOX      TEXT("spdm.Inbox")
    //#define PROPERTY_SOURCE_INBOX           TEXT("Inbox")
    #define PROPERTY_SOURCE_SPDM_OUTBOX     TEXT("spdm.Outbox")
    //#define PROPERTY_SOURCE_OUTBOX          TEXT("Outbox")
    #define PROPERTY_SOURCE_SPDM_DRAFT      TEXT("spdm.Draft")
    //#define PROPERTY_SOURCE_DRAFT           TEXT("Draft")
    #define PROPERTY_SOURCE_SPDM_SENT       TEXT("spdm.Sent")
    //#define PROPERTY_SOURCE_SENT            TEXT("Sent")
    #define PROPERTY_SOURCE_SPDM_TRASH      TEXT("spdm.Trash")
    //#define PROPERTY_SOURCE_TRASH           TEXT("Trash")

    #define PROPERTY_SOURCE_SPDM_DOWNLOAD_AGE   TEXT("spdm.downloadAge")    
    #define PROPERTY_SOURCE_SPDM_BODY_SIZE      TEXT("spdm.bodySize")    
    #define PROPERTY_SOURCE_SPDM_ATTACH_SIZE    TEXT("spdm.attachSize")


    #define SPDM_SYNCURL        TEXT("spdm.syncURL")
    #define SPDM_SERVERNAME     TEXT("spdm.serverName")
    #define SPDM_PASSWORD       TEXT("spdm.password")
    #define SPDM_USERNAME       TEXT("spdm.username")
    #define SPDM_DEVICEID       TEXT("spdm.deviceId")

    #define FAST                TEXT("fast")
    #define TWO_WAY             TEXT("two-way")
    #define SLOW                TEXT("slow")
    #define NONE                TEXT("none");

    #define SYNC_CONTACTS       TEXT("sync.contacts")
    #define SYNC_APPOINTMENTS   TEXT("sync.appointments")
    #define SYNC_TASKS          TEXT("sync.tasks")
    #define SYNC_FILES          TEXT("sync.files")
    #define SYNC_NOTES          TEXT("sync.notes")
    #define SYNC_FAVORITES      TEXT("sync.favorites")
    #define SYNC_MAILS          TEXT("sync.mails")

    #define HTTP_HEADER         TEXT("http://")
    #define HTTPS_HEADER        TEXT("https://")

    /*------------------ methods -----------------*/
    
    /*
    * Get the unique Device Identifier from PPC 2002 - 2003
    * see more at http://www.pocketpcdn.com/articles/serial_number2002.html
    *
    * @param deviceId     : the retrieved device id
    */

    void GetSerialNumberFromKernelIoControl(wchar_t* deviceId);

    /* 
    * Method to write communication settings into device. 
    * Used by setConfigurationParameters 
    *
    * @param rootContext  : the root context node
    * @param username     : user name
    * @param password     : user password
    * @param syncURL      : synchronization url
    * @param serverName   : the server uri used to address the sync server
    * @param deviceId     : device identifier
    * @param errorMsg     : the returned message to vb interface
    */

    void saveSyncMLPropsToDM(wchar_t* rootContext, wchar_t* username, wchar_t* password, 
                         wchar_t* syncURL, wchar_t* serverName, wchar_t* deviceId, wchar_t* errorMsg);

    /* 
    * Method to get communication settings from device. 
    * @param name  : name of the property to retrieve value of
    * @param value : value of the property
    */

    DWORD WINAPI getConfigParameter (wchar_t* name, wchar_t* value);

    /* 
    * Method to set communication settings into device. The parameters are retrieved by Visual Basic interface
    *
    * @param username     : user name
    * @param password     : user password
    * @param syncURL      : synchronization url
    * @param serverName   : the server uri used to address the sync server
    * @param errorMsg     : the returned message to vb interface
    */

    DWORD WINAPI setConfigParameters(wchar_t *username, wchar_t* password, 
                                 wchar_t* syncURL, wchar_t* serverName, wchar_t* errorMsg);



    /*
    * Method to get the synchronization setting parameters.
    * 
    * @param sourceName     : source name of which get parameter's value
    * @param propertyName   : name of property
    * @param propertyValue  : value of property
    */

    DWORD WINAPI getSourceParameter (LPWSTR sourceName, LPWSTR propertyName,  LPWSTR propertyValue);



    /*
    * Method to set the synchronization setting parameters.
    * 
    * @param sourceName     : source name of which get parameter's value
    * @param propertyName   : name of property
    * @param propertyValue  : value of property
    * @param errorMsg       : returned error message
    */

    DWORD WINAPI setSourceParameters (wchar_t* sourceName, wchar_t* propertyName, 
                                      wchar_t* propertyValue, wchar_t* errorMsg);


    /*
    * Method to get the client configurations. These property are set by installing process.
    * These are extra parameters not used in synchronization process 
    * but are needed for example to show or hide some fields in GUI interface.
    * 
    * @param sourceName     : source name of which get parameter's value
    * @param propertyName   : name of property
    * @param propertyValue  : value of property
    */

    DWORD WINAPI getClientConfiguration  (wchar_t* sourceName, wchar_t* propertyName, 
                                            wchar_t* propertyValue);
    
    DWORD getClientConfigurationInternal (wchar_t* sourceName, wchar_t* propertyName, 
                                            wchar_t* propertyValue, BOOL isFromVB);

    DWORD WINAPI setClientConfiguration(wchar_t* sourceName, wchar_t* propertyName, 
                                     wchar_t* propertyValue, wchar_t* errorMsg);

    wchar_t* getProperty(wchar_t* fullContext, wchar_t* property, wchar_t* buf = NULL, int size = 0);
    void setProperty(wchar_t* fullContext, wchar_t* property, wchar_t* value);    


    
#endif