/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_MAIL_CONTAINER
#define INCL_MAIL_CONTAINER

#include "base/fscapi.h"
#include "base/util/ArrayList.h"
#include "base/util/ArrayElement.h"
#include "spds/constants.h"
#include "spds/SyncItem.h"

class MailContainer{
       
private:
    wchar_t* entryID;
    wchar_t* subject;
    wchar_t* body;
    wchar_t* to;
    wchar_t* headers;
    

    int lenRfc2822;

public:

    /**
     * Constructor: create a MailContainer
     */
    MailContainer();    
    ~MailContainer() ;        
    
    void initialize();
    
    void setEntryID(wchar_t* t);
    wchar_t* getEntryID();

    wchar_t* getSubject();
    void setSubject(wchar_t* t);

    wchar_t* getBody();
    void setBody(wchar_t* t);

    wchar_t* getTo();
    void setTo(wchar_t* t);
    
    void setHeaders(wchar_t* t);
    wchar_t* getHeaders();

    /*
    * To convert into rfc2822 all the internal properties set into object.
    * It returns a wchar_t created with the new operator and must be descarded by the caller
    */
    wchar_t* toRfc2822();

    /*
    * To convert into object the wchar_t arrived by syncml 
    */    
    void toMailContainer(wchar_t* t);
    
    /**
    * gets the len of the rfc2822 transformation. 
    */
    int getLenRfc2822();


};

#endif
