/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_MAIL_ITEM
    #define INCL_MAIL_ITEM

#include "base/util/ArrayElement.h"
#include "base/util/utils.h"
#include "base/Log.h"

/**
* This class represents the mail item inside the cache file that contains the current 
* elements into all folder.
* See the MailInfo.h too.
*/
   
class MailItem: public ArrayElement {

    private:
      
        void initialize();
        
        /*
        * The id of the message. It is b64 coded
        */
        wchar_t* id;
        
        /*
        * The flag to indicate if the mail is arleay read
        */
        BOOL read;
        
        /*
        * The folder in which the message is stored in
        * The default value are:
        *  'I' for 'Inbox'
        *  'O' for 'Outbox'
        *  'D' for 'Draft'
        *  'S' for 'Sent'
        *  'T' for 'Trash'
        */
        wchar_t* folder;

    public:
    
        MailItem();
        ~MailItem();

        void setId(wchar_t* t);
        wchar_t* getId();


        void setRead(wchar_t* t);
        void setRead(BOOL t);
        BOOL getRead();

        void setFolder(wchar_t* t);
        wchar_t* getFolder();

        ArrayElement* clone();
};
#endif