/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef INCL_MAINCPP
    #define INCL_MAINCPP

    #include <windows.h>
    #include "base/Log.h"
 
    
    /*
    * method of dll called by Visual Basic.
    * @param vbErrorMsg - the param that accepts errors to return to VB interface
    * @param path - path of application installed on device VB passed to dll
    */
    
    DWORD WINAPI synchronization (wchar_t* vbErrorMsg, wchar_t* path);
    
    DWORD WINAPI synchronizationMailOnly ();

    /*      
     * Entry point to kickoff the synchronization process, specifying which
     * sources to synchronize.
     *
     * @param path    : the install path of the SyncClient PIM application on 
     *                  the device
     * @param sources : NULL terminated array of strings containing the source
     *                  name of the sources to synchronize
     */
    DWORD WINAPI synchronizeMultipleSources (const wchar_t* path, const wchar_t** sources);

    /*      
     * Entry point to kickoff the synchronization process, both specifying the 
     * sources or not. The default is to make all the configured sources.
     *
     * @param path    : the install path of the SyncClient PIM application on 
     *                  the device
     * @param sources : NULL terminated array of strings containing the source
     *                  name of the sources to synchronize
     */

    DWORD WINAPI synchronize (wchar_t *errmsg, const wchar_t* path, const wchar_t** sources);
    
    /*
    * get the log level set into client properties
    */
    LogLevel getLOGLevel();

    DWORD WINAPI settings();
#endif