/*
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "stdafx.h"
#include "setup.h"
#include "ce_setup.h"
#include <cfgmgrapi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CSetupApp

BEGIN_MESSAGE_MAP(CSetupApp, CWinApp)
	//{{AFX_MSG_MAP(CSetupApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupApp construction

CSetupApp::CSetupApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSetupApp object

CSetupApp theApp;


///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////
////////////////
////////////////   FUNAMBOL MODIFICATION FOR CAB INSTALLATION
////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////


#define ACCOUNT L"<wap-provisioningdoc> \
                    <characteristic type=\"EMAIL2\"> \
                      <characteristic type=\"{D671C70B-8EE3-4881-8045-2AEE6F731B78}\"> \
                         <parm name=\"SERVICENAME\" value=\"Funambol\"/> \
                         <parm name=\"SERVICETYPE\" value=\"Funambol\"/> \
                         <parm name=\"INSERVER\"    value=\"sync.funambol.com\"/> \
                         <parm name=\"OUTSERVER\"   value=\"sync.funambol.com\"/> \
                         <parm name=\"AUTHNAME\"    value=\"username\"/> \
                         <parm name=\"AUTHSECRET\"  value=\"password\"/> \
                         <parm name=\"DOMAIN\"      value=\"funambol.com\"/> \
                         <parm name=\"REPLYADDR\"   value=\"test.user@somewhere.com\"/> \
                         <parm name=\"NAME\"        value=\"Test User\"/> \
                       </characteristic> \
                     </characteristic> \
                  </wap-provisioningdoc>"

#define ACCOUNT_DEL L"<wap-provisioningdoc>\
                    <characteristic type=\"EMAIL2\">\
                    <nocharacteristic type=\"{D671C70B-8EE3-4881-8045-2AEE6F731B78}\"/>\
                    </characteristic>\
                    </wap-provisioningdoc>\
                "

void print(TCHAR *pFormat, ...) {
   va_list ArgList;
   TCHAR   Buffer[256];

   va_start (ArgList, pFormat);

   (void)wvsprintf (Buffer, pFormat, ArgList);

   MessageBox(NULL, Buffer, TEXT(""), MB_OK);

   va_end(ArgList);
}


void createAccount() {
    WCHAR* account = ACCOUNT;
    LPWSTR out = NULL;

    HRESULT ret = DMProcessConfigXML(account, CFGFLAG_PROCESS, &out);
    
    if (ret != 0)
        print(L"Error in creating Funambol account: code: %lx", ret);
}

void deleteAccount() {
    WCHAR* account = ACCOUNT;
    LPWSTR out = NULL;
    
    
    HRESULT ret = DMProcessConfigXML(account, CFGFLAG_PROCESS, &out);
    
    if (ret != 0)
        print(L"Error in deleting Funambol account: code: %lx", ret);
}


codeINSTALL_INIT
Install_Init(
    HWND        hwndParent,
    BOOL        fFirstCall,
    BOOL        fPreviouslyInstalled,
    LPCTSTR     pszInstallDir
)
{
AFX_MANAGE_STATE(AfxGetStaticModuleState());
// MessageBox (NULL, TEXT("Install_Init"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
return codeINSTALL_INIT_CONTINUE;
}

codeINSTALL_EXIT
Install_Exit(   HWND    hwndParent,
                LPCTSTR pszInstallDir,
                WORD    cFailedDirs,
                WORD    cFailedFiles,
                WORD    cFailedRegKeys,
                WORD    cFailedRegVals,
                WORD    cFailedShortcuts)  {

    AFX_MANAGE_STATE(AfxGetStaticModuleState());

    createAccount();
    
    return codeINSTALL_EXIT_DONE;
}

codeUNINSTALL_INIT
Uninstall_Init( HWND        hwndParent,
                LPCTSTR     pszInstallDir) {

    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    // MessageBox (NULL, TEXT("Uninstall_Init"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
    
    deleteAccount();    
   
    return codeUNINSTALL_INIT_CONTINUE;

}

codeUNINSTALL_EXIT
Uninstall_Exit(HWND    hwndParent) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());

    // MessageBox (NULL, TEXT("Uninstall_Exit"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
   
    return codeUNINSTALL_EXIT_DONE;
}